package dev.shadowsoffire.apotheosis.adventure.client;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.blaze3d.vertex.DefaultVertexFormat;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingTableTileRenderer;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingTableTileRenderer;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureKeys;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureModuleClient;
import dev.shadowsoffire.apotheosis.adventure.client.GemModel;
import dev.shadowsoffire.apotheosis.adventure.client.SocketTooltipRenderer;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.io.IOException;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.client.Minecraft;
import net.minecraft.client.multiplayer.ClientLevel;
import net.minecraft.client.renderer.ShaderInstance;
import net.minecraft.client.renderer.item.ItemProperties;
import net.minecraft.client.resources.model.BakedModel;
import net.minecraft.client.resources.model.ModelResourceLocation;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.client.event.ModelEvent;
import net.minecraftforge.client.event.RegisterClientTooltipComponentFactoriesEvent;
import net.minecraftforge.client.event.RegisterKeyMappingsEvent;
import net.minecraftforge.client.event.RegisterShadersEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.Mod.EventBusSubscriber;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;

@EventBusSubscriber(modid = "apotheosis", value = {Dist.CLIENT}, bus = Mod.EventBusSubscriber.Bus.MOD)
public class ModBusSub {
  @SubscribeEvent
  public static void models(ModelEvent.RegisterAdditional e) {
    e.register(ReforgingTableTileRenderer.HAMMER);
    e.register(AugmentingTableTileRenderer.STAR_CUBE);
  }
  
  @SubscribeEvent
  public static void tooltipComps(RegisterClientTooltipComponentFactoriesEvent e) {
    e.register(SocketTooltipRenderer.SocketComponent.class, SocketTooltipRenderer::new);
  }
  
  @SubscribeEvent
  public static void addGemModels(ModelEvent.RegisterAdditional e) {
    Set<ResourceLocation> locs = Minecraft.m_91087_().m_91098_().m_214159_("models", loc -> ("apotheosis".equals(loc.m_135827_()) && loc.m_135815_().contains("/gems/") && loc.m_135815_().endsWith(".json"))).keySet();
    for (ResourceLocation s : locs) {
      String path = s.m_135815_().substring("models/".length(), s.m_135815_().length() - ".json".length());
      e.register(new ResourceLocation("apotheosis", path));
    } 
  }
  
  @SubscribeEvent
  public static void replaceGemModel(ModelEvent.ModifyBakingResult e) {
    ModelResourceLocation key = new ModelResourceLocation(Apotheosis.loc("gem"), "inventory");
    BakedModel oldModel = (BakedModel)e.getModels().get(key);
    if (oldModel != null)
      e.getModels().put(key, new GemModel(oldModel, e.getModelBakery())); 
  }
  
  @SubscribeEvent
  public static void shaderRegistry(RegisterShadersEvent event) throws IOException {
    event.registerShader(new ShaderInstance(event.getResourceProvider(), new ResourceLocation("apotheosis:gray"), DefaultVertexFormat.f_85812_), shaderInstance -> AdventureModuleClient.CustomRenderTypes.grayShader = shaderInstance);
  }
  
  @SubscribeEvent
  public static void keys(RegisterKeyMappingsEvent e) {
    e.register(AdventureKeys.TOGGLE_RADIAL);
  }
  
  @SubscribeEvent
  public static void client(FMLClientSetupEvent e) {
    if (Apotheosis.enableAdventure)
      e.enqueueWork(() -> ItemProperties.register((Item)Adventure.Items.GEM.get(), Apotheosis.loc("rarity"), ())); 
  }
}
